<?php

/**
 * TermineDB.class.php
 *
 * Einrichtungstermine: Kalender für alle Termine einer Einrichtung
 *
 * @package	RFT
 *
 * @author	Henning Voss, vosshe@fh-trier.de
 * @author	David Klober, kloberd@fh-trier.de
 * @author	Marcus Haberkorn, haberkorn@fh-trier.de
 * @mail	elearning@fh-trier.de
 * @copyright	RFT 2006-2010
 */


require_once ("Termin.class.php");

class TermineDB
{
    private static $inst_id = "";
    private static $seminare;

    private static function readSeminare($inst_id, $user_id)
    {
        if(TermineDB::$inst_id != $inst_id)
		{
			$db = new DB_Seminar;
			$sql = "SELECT * FROM seminare WHERE " /*Institut_id = '%s' AND*/." visible = 1";
			$db->queryf($sql, $inst_id);
			TermineDB::$seminare = array();
			while($db->next_record())
			{
				TermineDB::$seminare[$db->f('Seminar_id')] = array(
					'id' => $db->f('Seminar_id'),
					'terms' => unserialize($db->f('metadata_dates')),
					'start_time' => $db->f('start_time'),
					'duration_time' => $db->f('duration_time'),
					'name' => $db->f('Name'),
				);
			}
			TermineDB::$inst_id = $inst_id;
		}
    }
    
    public static function &getSeminar($seminar_id)
    {
        return TermineDB::$seminare[$seminar_id];
    }

    public static function getTermsOfDay($day, $inst_id, $user_id)
    {
        TermineDB::readSeminare($inst_id, $user_id);
        $day_start = mktime(0, 0, 0, idate('m', $day), idate('d', $day), idate('Y', $day));
        $day_end = mktime(23, 59, 59, idate('m', $day), idate('d', $day), idate('Y', $day));
        
        $db = new DB_Seminar;
        $sql = "SELECT * FROM termine t LEFT JOIN seminare s ON(t.range_id = s.Seminar_id) WHERE s.Institut_id = '%s' AND s.visible = 1 AND date >= %s AND date <= %s";
		$db->queryf($sql, $inst_id, $day_start, $day_end);
		$result = array();
		while($db->next_record())
		{
				$result[] = new Termin($db);
		}
		return Termin::sort($result); 
	}
}
?>
